OpenShot Audio Library | OpenShotAudio: juce::CharPointer_UTF16 Class Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
juce::CharPointer_UTF16 Class Referencefinal

`#include <juce_CharPointer_UTF16.h>`

## Public Types
enum | { byteOrderMarkBE1 = 0xfe , byteOrderMarkBE2 = 0xff , byteOrderMarkLE1 = 0xff , byteOrderMarkLE2 = 0xfe }
using | CharType = int16

## Public Member Functions
| CharPointer_UTF16 (const CharType *rawPointer) noexcept
| CharPointer_UTF16 (const CharPointer_UTF16 &other)=default
CharPointer_UTF16 | operator= (CharPointer_UTF16 other) noexcept
CharPointer_UTF16 | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_UTF16 other) const noexcept
bool | operator!= (CharPointer_UTF16 other) const noexcept
bool | operator<= (CharPointer_UTF16 other) const noexcept
bool | operator< (CharPointer_UTF16 other) const noexcept
bool | operator>= (CharPointer_UTF16 other) const noexcept
bool | operator> (CharPointer_UTF16 other) const noexcept
CharType * | getAddress () const noexcept
| operator const CharType * () const noexcept
bool | isEmpty () const noexcept
bool | isNotEmpty () const noexcept
juce_wchar | operator* () const noexcept
CharPointer_UTF16 | operator++ () noexcept
CharPointer_UTF16 | operator-- () noexcept
juce_wchar | getAndAdvance () noexcept
CharPointer_UTF16 | operator++ (int) noexcept
void | operator+= (int numToSkip) noexcept
void | operator-= (int numToSkip) noexcept
juce_wchar | operator[] (int characterIndex) const noexcept
CharPointer_UTF16 | operator+ (int numToSkip) const noexcept
CharPointer_UTF16 | operator- (int numToSkip) const noexcept
void | write (juce_wchar charToWrite) noexcept
void | writeNull () const noexcept
size_t | length () const noexcept
size_t | lengthUpTo (size_t maxCharsToCount) const noexcept
size_t | lengthUpTo (CharPointer_UTF16 end) const noexcept
size_t | sizeInBytes () const noexcept
CharPointer_UTF16 | findTerminatingNull () const noexcept
template<typename CharPointer >
void | writeAll (CharPointer src) noexcept
void | writeAll (CharPointer_UTF16 src) noexcept
template<typename CharPointer >
size_t | writeWithDestByteLimit (CharPointer src, size_t maxDestBytes) noexcept
template<typename CharPointer >
void | writeWithCharLimit (CharPointer src, int maxChars) noexcept
template<typename CharPointer >
int | compare (CharPointer other) const noexcept
template<typename CharPointer >
int | compareUpTo (CharPointer other, int maxChars) const noexcept
template<typename CharPointer >
int | compareIgnoreCase (CharPointer other) const noexcept
template<typename CharPointer >
int | compareIgnoreCaseUpTo (CharPointer other, int maxChars) const noexcept
template<typename CharPointer >
int | indexOf (CharPointer stringToFind) const noexcept
int | indexOf (juce_wchar charToFind) const noexcept
int | indexOf (juce_wchar charToFind, bool ignoreCase) const noexcept
bool | isWhitespace () const noexcept
bool | isDigit () const noexcept
bool | isLetter () const noexcept
bool | isLetterOrDigit () const noexcept
bool | isUpperCase () const noexcept
bool | isLowerCase () const noexcept
juce_wchar | toUpperCase () const noexcept
juce_wchar | toLowerCase () const noexcept
int | getIntValue32 () const noexcept
int64 | getIntValue64 () const noexcept
double | getDoubleValue () const noexcept
CharPointer_UTF16 | findEndOfWhitespace () const noexcept
void | incrementToEndOfWhitespace () noexcept
CharPointer_UTF16 | atomicSwap (CharPointer_UTF16 newValue)

## Static Public Member Functions
static size_t | getBytesRequiredFor (juce_wchar charToWrite) noexcept
template<class CharPointer >
static size_t | getBytesRequiredFor (CharPointer text) noexcept
static bool | canRepresent (juce_wchar character) noexcept
static bool | isValidString (const CharType *dataToTest, int maxBytesToRead)
static bool | isByteOrderMarkBigEndian (const void *possibleByteOrder) noexcept
static bool | isByteOrderMarkLittleEndian (const void *possibleByteOrder) noexcept

## Detailed Description

Wraps a pointer to a null-terminated UTF-16 character string, and provides various methods to operate on the data.

See also
  CharPointer_UTF8, CharPointer_UTF32

Definition at line 34 of file juce_CharPointer_UTF16.h.

## Member Typedef Documentation

## ◆ CharType

using juce::CharPointer_UTF16::CharType = int16

Definition at line 40 of file juce_CharPointer_UTF16.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

These values are the byte-order-mark (BOM) values for a UTF-16 stream.

Definition at line 476 of file juce_CharPointer_UTF16.h.

## Constructor & Destructor Documentation

## ◆ CharPointer_UTF16()

juce::CharPointer_UTF16::CharPointer_UTF16 | ( | const CharType * | rawPointer | ) |
| inlineexplicitnoexcept

Definition at line 43 of file juce_CharPointer_UTF16.h.

## Member Function Documentation

## ◆ atomicSwap()

CharPointer_UTF16 juce::CharPointer_UTF16::atomicSwap | ( | CharPointer_UTF16 | newValue | ) |
| inline

Atomically swaps this pointer for a new value, returning the previous value.

Definition at line 470 of file juce_CharPointer_UTF16.h.

## ◆ canRepresent()

static bool juce::CharPointer_UTF16::canRepresent | ( | juce_wchar | character | ) |
| inlinestaticnoexcept

Returns true if the given unicode character can be represented in this encoding.

Definition at line 433 of file juce_CharPointer_UTF16.h.

## ◆ compare()

template<typename CharPointer >

int juce::CharPointer_UTF16::compare | ( | CharPointer | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 321 of file juce_CharPointer_UTF16.h.

## ◆ compareIgnoreCase()

template<typename CharPointer >

int juce::CharPointer_UTF16::compareIgnoreCase | ( | CharPointer | other | ) | const
| inlinenoexcept

Compares this string with another one.

Definition at line 335 of file juce_CharPointer_UTF16.h.

## ◆ compareIgnoreCaseUpTo()

template<typename CharPointer >

int juce::CharPointer_UTF16::compareIgnoreCaseUpTo | ( | CharPointer | other,
|  | int | maxChars ) const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 342 of file juce_CharPointer_UTF16.h.

## ◆ compareUpTo()

template<typename CharPointer >

int juce::CharPointer_UTF16::compareUpTo | ( | CharPointer | other,
|  | int | maxChars ) const
| inlinenoexcept

Compares this string with another one, up to a specified number of characters.

Definition at line 328 of file juce_CharPointer_UTF16.h.

## ◆ findEndOfWhitespace()

CharPointer_UTF16 juce::CharPointer_UTF16::findEndOfWhitespace | ( |  | ) | const
| inlinenoexcept

Returns the first non-whitespace character in the string.

Definition at line 427 of file juce_CharPointer_UTF16.h.

## ◆ findTerminatingNull()

CharPointer_UTF16 juce::CharPointer_UTF16::findTerminatingNull | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the null character that terminates this string.

Definition at line 270 of file juce_CharPointer_UTF16.h.

## ◆ getAddress()

CharType * juce::CharPointer_UTF16::getAddress | ( |  | ) | const
| inlinenoexcept

Returns the address that this pointer is pointing to.

Definition at line 71 of file juce_CharPointer_UTF16.h.

## ◆ getAndAdvance()

juce_wchar juce::CharPointer_UTF16::getAndAdvance | ( |  | ) |
| inlinenoexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

Definition at line 117 of file juce_CharPointer_UTF16.h.

## ◆ getBytesRequiredFor() [1/2]

template<class CharPointer >

static size_t juce::CharPointer_UTF16::getBytesRequiredFor | ( | CharPointer | text | ) |
| inlinestaticnoexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format. The value returned does NOT include the terminating null character.

Definition at line 258 of file juce_CharPointer_UTF16.h.

## ◆ getBytesRequiredFor() [2/2]

static size_t juce::CharPointer_UTF16::getBytesRequiredFor | ( | juce_wchar | charToWrite | ) |
| inlinestaticnoexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

Definition at line 248 of file juce_CharPointer_UTF16.h.

Referenced by getBytesRequiredFor().

## ◆ getDoubleValue()

double juce::CharPointer_UTF16::getDoubleValue | ( |  | ) | const
| inlinenoexcept

Parses this string as a floating point double.

Definition at line 424 of file juce_CharPointer_UTF16.h.

## ◆ getIntValue32()

int juce::CharPointer_UTF16::getIntValue32 | ( |  | ) | const
| inlinenoexcept

Parses this string as a 32-bit integer.

Definition at line 404 of file juce_CharPointer_UTF16.h.

## ◆ getIntValue64()

int64 juce::CharPointer_UTF16::getIntValue64 | ( |  | ) | const
| inlinenoexcept

Parses this string as a 64-bit integer.

Definition at line 414 of file juce_CharPointer_UTF16.h.

## ◆ incrementToEndOfWhitespace()

void juce::CharPointer_UTF16::incrementToEndOfWhitespace | ( |  | ) |
| inlinenoexcept

Move this pointer to the first non-whitespace character in the string.

Definition at line 430 of file juce_CharPointer_UTF16.h.

## ◆ indexOf() [1/3]

template<typename CharPointer >

int juce::CharPointer_UTF16::indexOf | ( | CharPointer | stringToFind | ) | const
| inlinenoexcept

Returns the character index of a substring, or -1 if it isn't found.

Definition at line 367 of file juce_CharPointer_UTF16.h.

## ◆ indexOf() [2/3]

int juce::CharPointer_UTF16::indexOf | ( | juce_wchar | charToFind | ) | const
| inlinenoexcept

Returns the character index of a unicode character, or -1 if it isn't found.

Definition at line 373 of file juce_CharPointer_UTF16.h.

## ◆ indexOf() [3/3]

int juce::CharPointer_UTF16::indexOf | ( | juce_wchar | charToFind,
|  | bool | ignoreCase ) const
| inlinenoexcept

Returns the character index of a unicode character, or -1 if it isn't found.

Definition at line 379 of file juce_CharPointer_UTF16.h.

## ◆ isByteOrderMarkBigEndian()

static bool juce::CharPointer_UTF16::isByteOrderMarkBigEndian | ( | const void * | possibleByteOrder | ) |
| inlinestaticnoexcept

Returns true if the first pair of bytes in this pointer are the UTF16 byte-order mark (big endian). The pointer must not be null, and must contain at least two valid bytes.

Definition at line 487 of file juce_CharPointer_UTF16.h.

Referenced by juce::String::createStringFromData(), and juce::XmlDocument::getDocumentElement().

## ◆ isByteOrderMarkLittleEndian()

static bool juce::CharPointer_UTF16::isByteOrderMarkLittleEndian | ( | const void * | possibleByteOrder | ) |
| inlinestaticnoexcept

Returns true if the first pair of bytes in this pointer are the UTF16 byte-order mark (little endian). The pointer must not be null, and must contain at least two valid bytes.

Definition at line 501 of file juce_CharPointer_UTF16.h.

Referenced by juce::String::createStringFromData(), and juce::XmlDocument::getDocumentElement().

## ◆ isDigit()

bool juce::CharPointer_UTF16::isDigit | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is a digit.

Definition at line 388 of file juce_CharPointer_UTF16.h.

## ◆ isEmpty()

bool juce::CharPointer_UTF16::isEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if this pointer is pointing to a null character.

Definition at line 77 of file juce_CharPointer_UTF16.h.

## ◆ isLetter()

bool juce::CharPointer_UTF16::isLetter | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is a letter.

Definition at line 390 of file juce_CharPointer_UTF16.h.

## ◆ isLetterOrDigit()

bool juce::CharPointer_UTF16::isLetterOrDigit | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is a letter or digit.

Definition at line 392 of file juce_CharPointer_UTF16.h.

## ◆ isLowerCase()

bool juce::CharPointer_UTF16::isLowerCase | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is lower-case.

Definition at line 396 of file juce_CharPointer_UTF16.h.

## ◆ isNotEmpty()

bool juce::CharPointer_UTF16::isNotEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if this pointer is not pointing to a null character.

Definition at line 80 of file juce_CharPointer_UTF16.h.

## ◆ isUpperCase()

bool juce::CharPointer_UTF16::isUpperCase | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is upper-case.

Definition at line 394 of file juce_CharPointer_UTF16.h.

## ◆ isValidString()

static bool juce::CharPointer_UTF16::isValidString | ( | const CharType * | dataToTest,
|  | int | maxBytesToRead )
| inlinestatic

Returns true if this data contains a valid string in this encoding.

Definition at line 440 of file juce_CharPointer_UTF16.h.

## ◆ isWhitespace()

bool juce::CharPointer_UTF16::isWhitespace | ( |  | ) | const
| inlinenoexcept

Returns true if the first character of this string is whitespace.

Definition at line 386 of file juce_CharPointer_UTF16.h.

## ◆ length()

size_t juce::CharPointer_UTF16::length | ( |  | ) | const
| inlinenoexcept

Returns the number of characters in this string.

Definition at line 202 of file juce_CharPointer_UTF16.h.

## ◆ lengthUpTo() [1/2]

size_t juce::CharPointer_UTF16::lengthUpTo | ( | CharPointer_UTF16 | end | ) | const
| inlinenoexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

Definition at line 232 of file juce_CharPointer_UTF16.h.

## ◆ lengthUpTo() [2/2]

size_t juce::CharPointer_UTF16::lengthUpTo | ( | size_t | maxCharsToCount | ) | const
| inlinenoexcept

Returns the number of characters in this string, or the given value, whichever is lower.

Definition at line 226 of file juce_CharPointer_UTF16.h.

## ◆ operator const CharType *()

juce::CharPointer_UTF16::operator const CharType * | ( |  | ) | const
| inlinenoexcept

Returns the address that this pointer is pointing to.

Definition at line 74 of file juce_CharPointer_UTF16.h.

## ◆ operator!=()

bool juce::CharPointer_UTF16::operator!= | ( | CharPointer_UTF16 | other | ) | const
| inlinenoexcept

Definition at line 64 of file juce_CharPointer_UTF16.h.

## ◆ operator*()

juce_wchar juce::CharPointer_UTF16::operator* | ( |  | ) | const
| inlinenoexcept

Returns the unicode character that this pointer is pointing to.

Definition at line 83 of file juce_CharPointer_UTF16.h.

## ◆ operator+()

CharPointer_UTF16 juce::CharPointer_UTF16::operator+ | ( | int | numToSkip | ) | const
| inlinenoexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

Definition at line 165 of file juce_CharPointer_UTF16.h.

## ◆ operator++() [1/2]

CharPointer_UTF16 juce::CharPointer_UTF16::operator++ | ( |  | ) |
| inlinenoexcept

Moves this pointer along to the next character in the string.

Definition at line 94 of file juce_CharPointer_UTF16.h.

## ◆ operator++() [2/2]

CharPointer_UTF16 juce::CharPointer_UTF16::operator++ | ( | int |  | ) |
| inlinenoexcept

Moves this pointer along to the next character in the string.

Definition at line 128 of file juce_CharPointer_UTF16.h.

## ◆ operator+=()

void juce::CharPointer_UTF16::operator+= | ( | int | numToSkip | ) |
| inlinenoexcept

Moves this pointer forwards by the specified number of characters.

Definition at line 136 of file juce_CharPointer_UTF16.h.

Referenced by operator-=().

## ◆ operator-()

CharPointer_UTF16 juce::CharPointer_UTF16::operator- | ( | int | numToSkip | ) | const
| inlinenoexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

Definition at line 173 of file juce_CharPointer_UTF16.h.

## ◆ operator--()

CharPointer_UTF16 juce::CharPointer_UTF16::operator-- | ( |  | ) |
| inlinenoexcept

Moves this pointer back to the previous character in the string.

Definition at line 105 of file juce_CharPointer_UTF16.h.

## ◆ operator-=()

void juce::CharPointer_UTF16::operator-= | ( | int | numToSkip | ) |
| inlinenoexcept

Moves this pointer backwards by the specified number of characters.

Definition at line 151 of file juce_CharPointer_UTF16.h.

## ◆ operator<()

bool juce::CharPointer_UTF16::operator< | ( | CharPointer_UTF16 | other | ) | const
| inlinenoexcept

Definition at line 66 of file juce_CharPointer_UTF16.h.

## ◆ operator<=()

bool juce::CharPointer_UTF16::operator<= | ( | CharPointer_UTF16 | other | ) | const
| inlinenoexcept

Definition at line 65 of file juce_CharPointer_UTF16.h.

## ◆ operator=() [1/2]

CharPointer_UTF16 juce::CharPointer_UTF16::operator= | ( | CharPointer_UTF16 | other | ) |
| inlinenoexcept

Definition at line 50 of file juce_CharPointer_UTF16.h.

## ◆ operator=() [2/2]

CharPointer_UTF16 juce::CharPointer_UTF16::operator= | ( | const CharType * | text | ) |
| inlinenoexcept

Definition at line 56 of file juce_CharPointer_UTF16.h.

## ◆ operator==()

bool juce::CharPointer_UTF16::operator== | ( | CharPointer_UTF16 | other | ) | const
| inlinenoexcept

This is a pointer comparison, it doesn't compare the actual text.

Definition at line 63 of file juce_CharPointer_UTF16.h.

## ◆ operator>()

bool juce::CharPointer_UTF16::operator> | ( | CharPointer_UTF16 | other | ) | const
| inlinenoexcept

Definition at line 68 of file juce_CharPointer_UTF16.h.

## ◆ operator>=()

bool juce::CharPointer_UTF16::operator>= | ( | CharPointer_UTF16 | other | ) | const
| inlinenoexcept

Definition at line 67 of file juce_CharPointer_UTF16.h.

## ◆ operator[]()

juce_wchar juce::CharPointer_UTF16::operator[] | ( | int | characterIndex | ) | const
| inlinenoexcept

Returns the character at a given character index from the start of the string.

Definition at line 157 of file juce_CharPointer_UTF16.h.

## ◆ sizeInBytes()

size_t juce::CharPointer_UTF16::sizeInBytes | ( |  | ) | const
| inlinenoexcept

Returns the number of bytes that are used to represent this string. This includes the terminating null character.

Definition at line 240 of file juce_CharPointer_UTF16.h.

## ◆ toLowerCase()

juce_wchar juce::CharPointer_UTF16::toLowerCase | ( |  | ) | const
| inlinenoexcept

Returns a lower-case version of the first character of this string.

Definition at line 401 of file juce_CharPointer_UTF16.h.

## ◆ toUpperCase()

juce_wchar juce::CharPointer_UTF16::toUpperCase | ( |  | ) | const
| inlinenoexcept

Returns an upper-case version of the first character of this string.

Definition at line 399 of file juce_CharPointer_UTF16.h.

## ◆ write()

void juce::CharPointer_UTF16::write | ( | juce_wchar | charToWrite | ) |
| inlinenoexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

Definition at line 181 of file juce_CharPointer_UTF16.h.

## ◆ writeAll() [1/2]

template<typename CharPointer >

void juce::CharPointer_UTF16::writeAll | ( | CharPointer | src | ) |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes.

Definition at line 282 of file juce_CharPointer_UTF16.h.

## ◆ writeAll() [2/2]

void juce::CharPointer_UTF16::writeAll | ( | CharPointer_UTF16 | src | ) |
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes.

Definition at line 288 of file juce_CharPointer_UTF16.h.

## ◆ writeNull()

void juce::CharPointer_UTF16::writeNull | ( |  | ) | const
| inlinenoexcept

Writes a null character to this string (leaving the pointer's position unchanged).

Definition at line 196 of file juce_CharPointer_UTF16.h.

## ◆ writeWithCharLimit()

template<typename CharPointer >

void juce::CharPointer_UTF16::writeWithCharLimit | ( | CharPointer | src,
|  | int | maxChars )
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes. The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

Definition at line 314 of file juce_CharPointer_UTF16.h.

## ◆ writeWithDestByteLimit()

template<typename CharPointer >

size_t juce::CharPointer_UTF16::writeWithDestByteLimit | ( | CharPointer | src,
|  | size_t | maxDestBytes )
| inlinenoexcept

Copies a source string to this pointer, advancing this pointer as it goes. The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

Definition at line 304 of file juce_CharPointer_UTF16.h.

The documentation for this class was generated from the following file:

- juce_CharPointer_UTF16.h